//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		ComPort.cpp
// ߲:		Microsoft Visual C++ 6.0
// o͗:
// Ǝ:	E, VU
// 쐬:		27-Feb-2003	JP (ATMEL̨)
// ύX:
//
// xҰ:		avr@atmel.com
//
// :		ʐM߰ ̪
//
// ̑:
//=============================================================================

#include "ComPort.h"
#include <winbase.h>

//=============================================================================
// ݽ׸

ComPort::ComPort()
{
	commPortM = INVALID_HANDLE_VALUE;
}

//=============================================================================
// ޽׸

ComPort::~ComPort()
{
	if (commPortM != INVALID_HANDLE_VALUE)
		CloseHandle (commPortM);
}

//=============================================================================
// w肵COM߰ĂJ

BOOL ComPort::open(LPCTSTR port, DWORD baudRate, DWORD timeOut)
{
	// قĂ邱ƂmF
	if (commPortM != INVALID_HANDLE_VALUE)
		return FALSE;

	// COM߰ĂJ
	commPortM = CreateFile(port, GENERIC_READ | GENERIC_WRITE, 0, NULL,
				OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	if (commPortM == INVALID_HANDLE_VALUE)
		return FALSE;

	// ʐMɏՕ
	if (! SetupComm(commPortM, 1024, 1024))
	{
		CloseHandle(commPortM);
		return FALSE;
	}

	// رْʐMu\ݒ
	DCB dcb;

	ZeroMemory (&dcb, sizeof(DCB));
	dcb.DCBlength = sizeof(DCB);
	dcb.BaudRate = baudRate;
	dcb.fBinary = 1;
	dcb.fDtrControl = DTR_CONTROL_DISABLE;
	dcb.fRtsControl = RTS_CONTROL_DISABLE;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;

	if (!SetCommState(commPortM, &dcb))
	{
		CloseHandle(commPortM);
		return FALSE;
	}

	if (!setTimeOut(timeOut))
	{
		CloseHandle(commPortM);
		return FALSE;
	}

	return TRUE;
}

//=============================================================================
// Ԑݒ

BOOL ComPort::setTimeOut(DWORD timeOut)
{
	COMMTIMEOUTS ctmo;
	ZeroMemory (&ctmo, sizeof(COMMTIMEOUTS));
	ctmo.ReadIntervalTimeout = timeOut;
	ctmo.ReadTotalTimeoutMultiplier = timeOut;
	ctmo.ReadTotalTimeoutConstant = timeOut;

	return SetCommTimeouts(commPortM, &ctmo);
}

//=============================================================================
// ر ߰Ă̓o͊ɏՕj

BOOL ComPort::flush()
{
	if (commPortM == INVALID_HANDLE_VALUE)
		return FALSE;

	if (! PurgeComm(commPortM, PURGE_TXCLEAR|PURGE_RXCLEAR))
		return FALSE;

	return TRUE;
}

//=============================================================================
// COM߰Ă

BOOL ComPort::close()
{
	if (commPortM != INVALID_HANDLE_VALUE)
		CloseHandle (commPortM);

	commPortM = INVALID_HANDLE_VALUE;

	return TRUE;
}

//=============================================================================
// COM߰Ă'size'޲ď

BOOL ComPort::write(UCHAR *buffer, DWORD size)
{
	// COM߰ď̏ꍇɕA
	if (commPortM == INVALID_HANDLE_VALUE)
		return FALSE;

	DWORD written;

	if (!WriteFile (commPortM, buffer, size, &written, NULL))
		return FALSE;

	if (written != size)
		return FALSE;

	return TRUE;
}

//=============================================================================
// COM߰Ă'size'޲ēǂݍ

BOOL ComPort::read(UCHAR *buffer, DWORD size)
{
	// COM߰ď̏ꍇɕA
	if (commPortM == INVALID_HANDLE_VALUE)
		return FALSE;

	DWORD read;

	if (!ReadFile(commPortM, buffer, size, &read, NULL))
		return FALSE;

	return (read != size) ? FALSE : TRUE;
}
